<?xml version="1.0" encoding="UTF-8" ?>
<!--
 |  Copyright 2020 Adobe Systems Incorporated
 |
 |  Licensed under the Apache License, Version 2.0 (the "License");
 |  you may not use this file except in compliance with the License.
 |  You may obtain a copy of the License at
 |
 |      http://www.apache.org/licenses/LICENSE-2.0
 |
 |  Unless required by applicable law or agreed to in writing, software
 |  distributed under the License is distributed on an "AS IS" BASIS,
 |  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 |  See the License for the specific language governing permissions and
 |  limitations under the License.
-->
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <!-- ====================================================================== -->
    <!-- P A R E N T  P R O J E C T  D E S C R I P T I O N                      -->
    <!-- ====================================================================== -->
    <parent>
        <groupId>com.aem.vilt</groupId>
        <artifactId>aem-vilt</artifactId>
        <version>1.0.0-SNAPSHOT</version>
        <relativePath>../pom.xml</relativePath>
    </parent>

    <!-- ====================================================================== -->
    <!-- P R O J E C T  D E S C R I P T I O N                                   -->
    <!-- ====================================================================== -->
    <artifactId>aem-vilt.ui.frontend</artifactId>
    <packaging>pom</packaging>
    <name>AEM VILT - UI Frontend</name>


    <!-- ====================================================================== -->
    <!-- B U I L D   D E F I N I T I O N                                        -->
    <!-- ====================================================================== -->
    <build>
        <sourceDirectory>src/main/content/jcr_root</sourceDirectory>
        <plugins>
            <plugin>
                <groupId>com.github.eirslett</groupId>
                <artifactId>frontend-maven-plugin</artifactId>
                <configuration>
                    <nodeVersion>v12.22.7</nodeVersion>
                    <npmVersion>6.14.0</npmVersion>
                </configuration>
                <executions>
                    <execution>
                        <id>npm run test</id>
                        <phase>generate-resources</phase>
                        <goals>
                            <goal>npm</goal>
                        </goals>
                        <configuration>
                            <arguments>test</arguments>
                            <environmentVariables>
                                <CI>true</CI>
                            </environmentVariables>
                        </configuration>
                    </execution>
                    <execution>
                        <id>npm run build</id>
                        <phase>generate-resources</phase>
                        <goals>
                            <goal>npm</goal>
                        </goals>
                        <configuration>
                            <!-- Create development/production build -->
                            <arguments>run build${build.environment}</arguments>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-assembly-plugin</artifactId>
                <executions>
                    <execution>
                        <phase>package</phase>
                        <goals>
                            <goal>single</goal>
                        </goals>
                        <configuration>
                            <descriptors>
                                <descriptor>assembly.xml</descriptor>
                            </descriptors>
                            <appendAssemblyId>false</appendAssemblyId>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
        </plugins>
    </build>
    
    
    <profiles>
        <profile>
            <id>serverSideRender-runtime</id>
            
            <build>
                <pluginManagement>
                    <plugins>
                        <plugin>
                            <groupId>com.github.eirslett</groupId>
                            <artifactId>frontend-maven-plugin</artifactId>
                            <configuration>
                                <nodeVersion>v12.22.7</nodeVersion>
                                <npmVersion>6.14.0</npmVersion>
                            </configuration>
                            <executions>
                                <execution>
                                    <id>npm run test</id>
                                    <phase>generate-resources</phase>
                                    <goals>
                                        <goal>npm</goal>
                                    </goals>
                                    <configuration>
                                        <arguments>test</arguments>
                                        <environmentVariables>
                                            <CI>true</CI>
                                        </environmentVariables>
                                    </configuration>
                                </execution>
                                <execution>
                                    <id>npm run build-serverless</id>
                                    <phase>generate-resources</phase>
                                    <goals>
                                        <goal>npm</goal>
                                    </goals>
                                    <configuration>
                                        <arguments>run build-serverless</arguments>
                                    </configuration>
                                </execution>
                                <execution>
                                    <id>npm run deploy</id>
                                    <goals>
                                        <goal>npm</goal>
                                    </goals>
                                    <phase>install</phase>
                                    <configuration>
                                        <arguments>run deploy-ssr-ioruntime</arguments>
                                        
                                        <environmentVariables>
                                            <AIO_RUNTIME_NAMESPACE>${aio.runtime.namespace}</AIO_RUNTIME_NAMESPACE>
                                            <AIO_RUNTIME_AUTH>${aio.runtime.auth}</AIO_RUNTIME_AUTH>
                                        </environmentVariables>
                                    </configuration>
                                </execution>
                            
                            </executions>
                        </plugin>
                    </plugins>
                </pluginManagement>
            </build>
        </profile>
    </profiles>
</project>
